------------------------------------------------------------
IF 0 = (SELECT count(*) from [sysobjects] where ([xtype] = 'U' or [xtype] = 'V') and [name] = 'ut_Language')
BEGIN
CREATE TABLE [dbo].[ut_Language]
(
   [RecId]  integer NOT NULL
  ,[MandId] integer DEFAULT 1
  ,[LangId] integer DEFAULT 0
  ,[TextKey] char(30) DEFAULT ' '
  ,[LangText] char(64) DEFAULT ' '
  CONSTRAINT [Pk_Language]  PRIMARY KEY NONCLUSTERED ( [RecId] )
)
END
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_Language_KeyDel')
  DROP TRIGGER [dbo].[tr_Language_KeyDel]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_Language_KeyUpd')
  DROP TRIGGER [dbo].[tr_Language_KeyUpd]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'U' and [name] = 'ut_Language_Keys')
  DROP TABLE [dbo].[ut_Language_Keys]
GO

IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_Language' and sc.[name] = 'LangId')
BEGIN
  ALTER TABLE [dbo].[ut_Language] ADD [LangId] integer NOT NULL DEFAULT 0
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_Language' and sc.[name] = 'TextKey')
BEGIN
  ALTER TABLE [dbo].[ut_Language] ADD [TextKey] char(30) NOT NULL DEFAULT ' '
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_Language' and sc.[name] = 'LangText')
BEGIN
  ALTER TABLE [dbo].[ut_Language] ADD [LangText] char(64) NOT NULL DEFAULT ' '
END
GO
IF 30 > (select length from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_Language' and sc.[name] = 'TextKey')
BEGIN
  ALTER TABLE [dbo].[ut_Language] ALTER COLUMN [TextKey] char(30)
END
GO
IF 64 > (select length from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_Language' and sc.[name] = 'LangText')
BEGIN
  ALTER TABLE [dbo].[ut_Language] ALTER COLUMN [LangText] char(64)
END
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'V' and [name] = 'Language')
  DROP VIEW [dbo].[Language]
GO
CREATE VIEW [dbo].[Language] AS
  SELECT * FROM [dbo].[ut_Language]
GO
CREATE TABLE [dbo].[ut_Language_Keys]
(
   [DataRecId]  integer NOT NULL
  ,[DataMandId] integer DEFAULT 1
  ,[Key00_Value] CHAR(48) NOT NULL
  ,[Key01_Value] CHAR(48) NOT NULL
  CONSTRAINT [Pk_ut_Language_Keys]  PRIMARY KEY NONCLUSTERED ( [DataRecId] )
)
GO
CREATE TRIGGER [dbo].[tr_Language_KeyDel] ON [dbo].[ut_Language]
FOR DELETE
AS
  SET NOCOUNT ON
  DELETE FROM [dbo].[ut_Language_Keys] WITH (SERIALIZABLE)
  WHERE [DataRecId] IN (SELECT [RecId] FROM DELETED)
GO

CREATE TRIGGER [dbo].[tr_Language_KeyUpd] ON [dbo].[ut_Language]
FOR INSERT, UPDATE
AS
  SET NOCOUNT ON
  IF UPDATE([RecId]) OR UPDATE([MandId])
  BEGIN
    DELETE FROM [dbo].[ut_Language_Keys] WITH (SERIALIZABLE)
    WHERE [DataRecId] IN (SELECT [RecId] FROM DELETED)

    INSERT INTO [dbo].[ut_Language_Keys] WITH (SERIALIZABLE)
    ([DataRecId],[DataMandId],[Key00_Value],[Key01_Value])
    (SELECT [RecId],[MandId]
     ,UPPER(STR([LangId],8,0)+convert(char(30),[TextKey])+STR(RecId,10))
     ,UPPER(convert(char(30),[TextKey])+STR([LangId],8,0)+STR(RecId,10))

    FROM INSERTED)
  END
  ELSE
  BEGIN
    UPDATE [dbo].[ut_Language_Keys] WITH (SERIALIZABLE) SET
    [Key00_Value] = UPPER(STR([LangId],8,0)+convert(char(30),[TextKey])+STR([RecId],10))
   ,[Key01_Value] = UPPER(convert(char(30),[TextKey])+STR([LangId],8,0)+STR([RecId],10))
    FROM INSERTED WHERE [DataRecId] = [RecId]
  END
GO

UPDATE [dbo].[ut_Language] SET RecId = RecId
GO


------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Add_Language')
  DROP PROCEDURE [dbo].[up_Add_Language]
GO
CREATE PROCEDURE [dbo].[up_Add_Language] AS
  DECLARE @NeueId integer
  SET @NeueId = (SELECT MAX(RecId) from [dbo].[ut_Language])
  IF @NeueId IS NULL SET @NeueId = 0
  SET @NeueId = @NeueId + 1
  INSERT INTO [dbo].[ut_Language] (RecId) VALUES( @NeueId )
  IF @@ERROR = 0
  BEGIN
    SELECT @NeueId AS RecId
    RETURN
  END
  SELECT 0 AS RecId
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd_Language')
  DROP PROCEDURE [dbo].[up_Upd_Language]
GO
CREATE PROCEDURE [dbo].[up_Upd_Language]
  @RI integer
 ,@Parm_LangId integer
 ,@Parm_TextKey char(30)
 ,@Parm_LangText char(64)
AS
--BEGIN TRANSACTION
UPDATE [dbo].[ut_Language] SET
     [LangId] = @Parm_LangId
    ,[TextKey] = RTRIM(@Parm_TextKey)
    ,[LangText] = RTRIM(@Parm_LangText)
  WHERE RecId = @RI
--COMMIT TRANSACTION
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel_Language')
  DROP PROCEDURE [dbo].[up_Sel_Language]
GO
CREATE PROCEDURE [dbo].[up_Sel_Language]
  @RI integer
AS
SELECT
     [LangId]
    ,[TextKey]
    ,[LangText]
  FROM [dbo].[ut_Language]
  WHERE RecId = @RI
GO
------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Del_Language')
  DROP PROCEDURE [dbo].[up_Del_Language]
GO
CREATE PROCEDURE [dbo].[up_Del_Language]
  @RI integer
AS
  DELETE FROM [dbo].[ut_Language] WHERE RecId = @RI
GO
------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Reorg_Language')
  DROP PROCEDURE [dbo].[up_Reorg_Language]
GO
CREATE PROCEDURE [dbo].[up_Reorg_Language]
  @bDbcc integer,@bRecId integer
AS
  IF (@bRecId = 1)
  BEGIN
    DECLARE  C        CURSOR FOR SELECT RecId FROM [dbo].[ut_Language] ORDER BY RecId
    DECLARE  @CurrId  integer
    DECLARE  @NextId  integer
    --BEGIN TRANSACTION
    OPEN C
    SET @NextId = 1
    FETCH NEXT FROM C INTO @CurrId
    WHILE (@@FETCH_STATUS = 0)
    BEGIN
      IF @CurrId <> @NextId
      UPDATE [dbo].[ut_Language] SET RecId=@NextId WHERE CURRENT OF C
      SET @NextId = @NextId + 1
      FETCH NEXT FROM C INTO @CurrId
    END
    CLOSE C
    --COMMIT TRANSACTION
    DEALLOCATE C
  END

  IF (@bDbcc = 1)
  BEGIN
    DBCC DBREINDEX ( [ut_Language] )
  END

GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Append_Language')
  DROP PROCEDURE [dbo].[up_Append_Language]
GO
CREATE PROCEDURE [dbo].[up_Append_Language]
  @Parm_LangId integer
 ,@Parm_TextKey char(30)
 ,@Parm_LangText char(64)
AS
  DECLARE @NeueId    integer
  SET     @NeueId = (SELECT MAX(RecId) FROM [dbo].[ut_Language])
  IF @NeueId IS NULL SET @NeueId = 0
  SET @NeueId = @NeueId + 1
  INSERT INTO [dbo].[ut_Language] (
    RecId
   ,[LangId]
   ,[TextKey]
   ,[LangText]
     ) VALUES (
    @NeueId
   ,@Parm_LangId
   ,RTRIM(@Parm_TextKey)
   ,RTRIM(@Parm_LangText)
       )
  IF @@ERROR = 0
  BEGIN
    SELECT @NeueId AS RecId
    RETURN
  END
  SELECT 0 AS RecId
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_TrSel_Language')
  DROP PROCEDURE [dbo].[up_TrSel_Language]
GO
CREATE PROCEDURE [dbo].[up_TrSel_Language]
AS
  SELECT   RecId,
      LTRIM(RTRIM([TextKey]))
      +LTRIM(RTRIM([LangText]))
    AS Data
  FROM     [dbo].[ut_Language]
  WHERE    RecId > 0
  ORDER BY RecId
GO

CREATE INDEX [Ik_Key00] ON [dbo].[ut_Language_Keys]
( [Key00_Value],[DataRecId] )
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_First_Language_Key00')
  DROP PROCEDURE [dbo].[up_First_Language_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Last_Language_Key00')
  DROP PROCEDURE [dbo].[up_Last_Language_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior_Language_Key00')
  DROP PROCEDURE [dbo].[up_Prior_Language_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next_Language_Key00')
  DROP PROCEDURE [dbo].[up_Next_Language_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior50_Language_Key00')
  DROP PROCEDURE [dbo].[up_Prior50_Language_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next50_Language_Key00')
  DROP PROCEDURE [dbo].[up_Next50_Language_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindL_Language_Key00')
  DROP PROCEDURE [dbo].[up_FindL_Language_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindF_Language_Key00')
  DROP PROCEDURE [dbo].[up_FindF_Language_Key00]
GO

CREATE PROCEDURE [dbo].[up_First_Language_Key00]
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_Language_Keys] ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Last_Language_Key00]
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_Language_Keys] ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_Next_Language_Key00] @mRecNo integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_Language_Keys]
  WHERE [Key00_Value] > (SELECT [Key00_Value] FROM [dbo].[ut_Language_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Prior_Language_Key00] @mRecNo integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_Language_Keys]
  WHERE [Key00_Value] < (SELECT [Key00_Value] FROM [dbo].[ut_Language_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_Next50_Language_Key00] @mRecNo integer
AS
  SELECT TOP 50 [DataRecId] FROM [dbo].[ut_Language_Keys]
  WHERE [Key00_Value] > (SELECT [Key00_Value] FROM [dbo].[ut_Language_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Prior50_Language_Key00] @mRecNo integer
AS
  SELECT TOP 50 [DataRecId] FROM [dbo].[ut_Language_Keys]
  WHERE [Key00_Value] < (SELECT [Key00_Value] FROM [dbo].[ut_Language_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_FindF_Language_Key00] @xKey char(128),@xLen integer
AS
  SELECT a.[DataRecId] FROM
    ( SELECT TOP 1 [DataRecId],[Key00_Value] AS Key_Value FROM [dbo].[ut_Language_Keys]
      WHERE [Key00_Value] >= SUBSTRING(@xKey,1,@xLen)
      ORDER BY [Key00_Value]
    ) a
  WHERE a.Key_Value like SUBSTRING(@xKey,1,@xLen)+'%'
GO

CREATE PROCEDURE [dbo].[up_FindL_Language_Key00] @xKey char(128),@xLen integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_Language_Keys]
  WHERE [Key00_Value] like SUBSTRING(@xKey,1,@xLen)+'%'
  ORDER BY [Key00_Value] DESC
GO

CREATE INDEX [Ik_Key01] ON [dbo].[ut_Language_Keys]
( [Key01_Value],[DataRecId] )
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_First_Language_Key01')
  DROP PROCEDURE [dbo].[up_First_Language_Key01]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Last_Language_Key01')
  DROP PROCEDURE [dbo].[up_Last_Language_Key01]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior_Language_Key01')
  DROP PROCEDURE [dbo].[up_Prior_Language_Key01]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next_Language_Key01')
  DROP PROCEDURE [dbo].[up_Next_Language_Key01]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior50_Language_Key01')
  DROP PROCEDURE [dbo].[up_Prior50_Language_Key01]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next50_Language_Key01')
  DROP PROCEDURE [dbo].[up_Next50_Language_Key01]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindL_Language_Key01')
  DROP PROCEDURE [dbo].[up_FindL_Language_Key01]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindF_Language_Key01')
  DROP PROCEDURE [dbo].[up_FindF_Language_Key01]
GO

CREATE PROCEDURE [dbo].[up_First_Language_Key01]
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_Language_Keys] ORDER BY [Key01_Value]
GO

CREATE PROCEDURE [dbo].[up_Last_Language_Key01]
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_Language_Keys] ORDER BY [Key01_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_Next_Language_Key01] @mRecNo integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_Language_Keys]
  WHERE [Key01_Value] > (SELECT [Key01_Value] FROM [dbo].[ut_Language_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key01_Value]
GO

CREATE PROCEDURE [dbo].[up_Prior_Language_Key01] @mRecNo integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_Language_Keys]
  WHERE [Key01_Value] < (SELECT [Key01_Value] FROM [dbo].[ut_Language_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key01_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_Next50_Language_Key01] @mRecNo integer
AS
  SELECT TOP 50 [DataRecId] FROM [dbo].[ut_Language_Keys]
  WHERE [Key01_Value] > (SELECT [Key01_Value] FROM [dbo].[ut_Language_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key01_Value]
GO

CREATE PROCEDURE [dbo].[up_Prior50_Language_Key01] @mRecNo integer
AS
  SELECT TOP 50 [DataRecId] FROM [dbo].[ut_Language_Keys]
  WHERE [Key01_Value] < (SELECT [Key01_Value] FROM [dbo].[ut_Language_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key01_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_FindF_Language_Key01] @xKey char(128),@xLen integer
AS
  SELECT a.[DataRecId] FROM
    ( SELECT TOP 1 [DataRecId],[Key01_Value] AS Key_Value FROM [dbo].[ut_Language_Keys]
      WHERE [Key01_Value] >= SUBSTRING(@xKey,1,@xLen)
      ORDER BY [Key01_Value]
    ) a
  WHERE a.Key_Value like SUBSTRING(@xKey,1,@xLen)+'%'
GO

CREATE PROCEDURE [dbo].[up_FindL_Language_Key01] @xKey char(128),@xLen integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_Language_Keys]
  WHERE [Key01_Value] like SUBSTRING(@xKey,1,@xLen)+'%'
  ORDER BY [Key01_Value] DESC
GO

